function reinitiateGame()
{
   btnPause.enabled = true;
   btnPause._alpha = 100;
   if(nPlayers == 1)
   {
      player1.reinitiateGame();
      player1.jumpToLevel(nLevel1);
      player1.handicap(nHandicap1);
   }
   else
   {
      player1.reinitiateGame();
      player2.reinitiateGame();
      player1.jumpToLevel(nLevel1);
      player2.jumpToLevel(nLevel2);
      player1.handicap(nHandicap1);
      player2.handicap(nHandicap2);
      player1.setMultiplayer();
      player2.setMultiplayer();
      player1.setStars(nPlayer1Stars);
      player2.setStars(nPlayer2Stars);
   }
   bGameInitiated = true;
   startGame();
}
function startGame()
{
   nTimerGame = setInterval(game,50);
   var i = 1;
   while(i <= nPlayers)
   {
      eval("player" + i).startGame();
      i++;
   }
}
function game()
{
   if(isGameOver())
   {
      endGame();
   }
   if(nPlayers > 1)
   {
      if(player2.nDelay <= 0)
      {
         player2.applyAttack(player1.nAttack);
         player1.nAttack = 0;
      }
      if(player1.nDelay <= 0)
      {
         player1.applyAttack(player2.nAttack);
         player2.nAttack = 0;
      }
   }
}
function catchKey()
{
   var keyCode = Key.getCode();
   switch(keyCode)
   {
      case 88:
         showMsgBoxQuit();
         break;
      case 89:
         if(bMsgBoxOpened)
         {
            quitGame();
         }
         break;
      case 78:
         if(bMsgBoxOpened)
         {
            dontQuitGame();
         }
         break;
      case 13:
         btnContinueHandler();
   }
   if(isGameOver())
   {
      return undefined;
   }
   if(keyCode === 80)
   {
      pauseGame();
   }
   var i = 1;
   while(i <= nPlayers)
   {
      if(!eval("player" + i).bPaused && !eval("player" + i).bGameOver)
      {
         switch(keyCode)
         {
            case eval("player" + i).keyLeft:
               eval("player" + i).moveLeft();
               break;
            case eval("player" + i).keyRight:
               eval("player" + i).moveRight();
               break;
            case eval("player" + i).keyMoveDown:
               eval("player" + i).moveDown();
               break;
            case eval("player" + i).keyDrop:
               eval("player" + i).dropDown();
               break;
            case eval("player" + i).keyRotate:
               eval("player" + i).rotate();
         }
      }
      i++;
   }
   updateAfterEvent();
}
function isGameOver()
{
   var i = 1;
   while(i <= nPlayers)
   {
      if(eval("player" + i).bGameOver)
      {
         return true;
      }
      i++;
   }
}
function endGame()
{
   clearInterval(nTimerGame);
   btnPause.enabled = false;
   btnPause._alpha = 50;
   if(nPlayers > 1)
   {
      var i = 1;
      while(i <= nPlayers)
      {
         eval("player" + i).stopGame();
         if(eval("player" + i).bGameOver)
         {
            eval("player" + i).lose();
         }
         else
         {
            eval("player" + i).win();
            if(i == 1)
            {
               nPlayer1Stars++;
            }
            else
            {
               nPlayer2Stars++;
            }
         }
         if(eval("player" + i).nStars > 1)
         {
            nMatchWinner = i;
            if(i == 1)
            {
               nMatchPoint1++;
            }
            if(i == 2)
            {
               nMatchPoint2++;
            }
         }
         i++;
      }
   }
   else
   {
      player1.stopGame();
      player1.gameover();
   }
   _root.attachMovie("mcContinue","mcContinue",_root.getNextHighestDepth(),{_x:0,_y:26});
   mcContinue.btnContinue.onPress = function()
   {
      btnContinueHandler();
   };
}
function destroyPlayers()
{
   var i = 1;
   while(i <= nPlayers)
   {
      eval("player" + i).destroy();
      eval("player" + i + " = null");
      i++;
   }
}
function pauseGame()
{
   if(bMsgBoxOpened)
   {
      return undefined;
   }
   if(isGameOver())
   {
      return undefined;
   }
   bGamePaused = !bGamePaused;
   var i = 1;
   while(i <= nPlayers)
   {
      if(eval("player" + i).bPaused)
      {
         eval("player" + i).startGame();
      }
      else
      {
         eval("player" + i).pauseGame();
      }
      i++;
   }
}
function btnContinueHandler()
{
   if(isGameOver() && !bMsgBoxOpened)
   {
      mcContinue.removeMovieClip();
      if(nPlayers == 1)
      {
         quitGame();
      }
      else if(nMatchWinner > 0)
      {
         quitGame();
      }
      else
      {
         reinitiateGame();
      }
   }
}
function showMsgBoxQuit()
{
   if(!bGamePaused)
   {
      pauseGame();
   }
   if(bMsgBoxOpened)
   {
      return undefined;
   }
   bMsgBoxOpened = true;
   btnPause.enabled = false;
   btnPause._alpha = 50;
   btnQuit.enabled = false;
   btnQuit._alpha = 50;
   _root.attachMovie("mcMsgBoxQuit","mcMsgBoxQuit",_root.getNextHighestDepth(),{_x:0,_y:0});
   mcMsgBoxQuit._x = Stage.width / 2 - mcMsgBoxQuit._width / 2;
   mcMsgBoxQuit._y = Stage.height / 2 - mcMsgBoxQuit._height / 2;
   mcMsgBoxQuit.btnYes.onPress = function()
   {
      quitGame();
   };
   mcMsgBoxQuit.btnNo.onPress = function()
   {
      dontQuitGame();
   };
}
function dontQuitGame()
{
   mcMsgBoxQuit.removeMovieClip();
   if(!isGameOver())
   {
      btnPause.enabled = true;
      btnPause._alpha = 100;
   }
   btnQuit.enabled = true;
   btnQuit._alpha = 100;
   bMsgBoxOpened = false;
   pauseGame();
}
function quitGame()
{
   mcMsgBoxQuit.removeMovieClip();
   mcContinue.removeMovieClip();
   Key.removeListener(this);
   clearInterval(nTimerGame);
   bGameInitiated = false;
   destroyPlayers();
   gotoAndPlay(102);
}
stop();
var nTimerGame;
var bGameInitiated;
var bMsgBoxOpened = false;
var bGamePaused = false;
var nPlayer1Stars = 0;
var nPlayer2Stars = 0;
var nMatchWinner = 0;
if(!bGameInitiated)
{
   destroyPlayers();
   if(nPlayers == 1)
   {
      var player1 = new Player(sPlayerName1,175,35);
      player1.setKeys(37,39,40,38);
      player1.jumpToLevel(nLevel1);
      player1.handicap(nHandicap1);
   }
   else
   {
      var player1 = new Player(sPlayerName1,280,35);
      var player2 = new Player(sPlayerName2,10,35);
      player1.setKeys(37,39,40,38,46);
      player2.setKeys(65,68,83,87,81);
      player1.jumpToLevel(nLevel1);
      player2.jumpToLevel(nLevel2);
      player1.handicap(nHandicap1);
      player2.handicap(nHandicap2);
      player1.setMultiplayer();
      player2.setMultiplayer();
   }
   bGameInitiated = true;
   startGame();
}
Key.removeListener(this);
Key.addListener(this);
this.onKeyDown = catchKey;
btnPause.onPress = function()
{
   pauseGame();
};
btnQuit.onPress = function()
{
   showMsgBoxQuit();
};
